jQuery(document).ready(function() {

    jQuery('#wp-forum-connect-user-login').submit(e => {

        e.preventDefault();

        jQuery.ajax({
            url: AudentioForumConnect.endpoints.userLogin,
            data: {
                'username': jQuery('#wp-forum-connect-user-username').val(),
                'password': jQuery('#wp-forum-connect-user-password').val(),
            },
            type: 'POST',
            success: resp => {
                resp = JSON.parse(resp);

                if (resp.error) {
                    jQuery('.wp-forum-connect-validation-error').text(resp.error).show();

                    return;
                }

                if (resp.success) {
                    window.location = jQuery('#wp-forum-connect-user-login-redirect').val();
                    window.location.reload();

                    return;
                }
            },
        });

    });

    jQuery('#commentform').submit(e => {

        e.preventDefault();

        jQuery('#commentform .submit').prop('disabled', true);

        jQuery('.wp-forum-connect-validation-error').text('').hide();

        let formData = new FormData(jQuery('#commentform')[0]);

        jQuery.ajax({
            url: AudentioForumConnect.endpoints.postComment,
            data: formData,
            processData: false,
            contentType: false,
            type: 'POST',
            success: resp => {
                resp = JSON.parse(resp);

                if (resp.error) {
                    jQuery('.wp-forum-connect-validation-error').text(resp.error).show();

                    jQuery('#commentform .submit').prop('disabled', false);

                    return;
                }

                if (resp.redirectUrl) {
                    window.location = resp.redirectUrl;

                    return;
                }

                jQuery('#comments .comment-list').append(resp.comment);

                jQuery('#commentform textarea').val('');

                jQuery('#commentform .submit').prop('disabled', false);
            },
        });

    });

    jQuery('body').on('click', '.wp-forum-connect-comment-vote-arrow', function (arrow) {
        if (!jQuery(arrow.target).data('canVote')) {
            return;
        }
        jQuery.ajax({
            url: AudentioForumConnect.endpoints.postVote,
            data: {
                'id': jQuery(arrow.target).data('id'),
                'type': jQuery(arrow.target).data('type'),
            },
            type: 'POST',
            success: resp => {
                resp = JSON.parse(resp);

                if (resp.comment) {
                    setVote(jQuery('#div-comment-' + resp.comment.id), resp.comment);
                }
            },
        });
    });

    function setVote(element, comment) {
        element.find('.wp-forum-connect-comment-vote-score').text(comment.vote_score).removeClass('positive negative');
        if (comment.vote_score > 0) {
            element.find('.wp-forum-connect-comment-vote-score').addClass('positive');
        }
        if (comment.vote_score < 0) {
            element.find('.wp-forum-connect-comment-vote-score').addClass('negative');
        }
        element.find('.wp-forum-connect-comment-vote-arrow').removeClass('voted');
        if (comment.voted == 'up') {
            element.find('.wp-forum-connect-comment-vote-up').addClass('voted');
        }
        if (comment.voted == 'down') {
            element.find('.wp-forum-connect-comment-vote-down').addClass('voted');
        }
    }

});