jQuery(document).ready(function() {

    jQuery.ajax(ajaxurl + '?action=xf_node_list', {
        dataType: 'json',
    })
    .done(function (resp) {
        jQuery(resp).each(function (index, node) {
            option = jQuery('<option />', {
                'value': node.id,
                'text': node.title,
                'selected': node.id == wpForumConnectForumId,
                'disabled': !node.selectable,
            });
            jQuery('#xf-thread-forum').append(option);
        });

        if (wpForumConnectForumId) {
            xfLoadThreadPrefixes();
            xfThreadConfigRefresh();
        }

        toggleFields();
    });

    jQuery('#xf-thread-id').keyup(function () {
        toggleFields();
    });

    jQuery('#xf-thread-forum').change(function () {
        wpForumConnectForumId = jQuery(this).val();
        xfLoadThreadPrefixes();
    });

    jQuery('#xf-thread-prefix').change(function () {
        wpForumConnectPrefixId = jQuery(this).val();
    });

    jQuery('#xf-thread-config-save').click(function () {
        jQuery.post(ajaxurl + '?action=xf_save_post_thread_config', {
            'post_id': wpForumConnectPostId,
            'thread_id': jQuery('#xf-thread-id').val(),
            'create_thread': jQuery('#xf-thread-create').val(),
            'forum_id': wpForumConnectForumId,
            'prefix_id': wpForumConnectPrefixId,
            'user_id': jQuery('#xf-thread-user-search').val(),
            'excerpt': jQuery('#xf-thread-excerpt').val(),
        })
        .done(function (resp) {
            resp = JSON.parse(resp);
            if (!resp.success) {
                alert(resp.message);
                return;
            }
            if (wpForumConnectForumId) {
                xfThreadConfigRefresh();
            }
            jQuery('#xf-create-thread-value').text(resp.data.create_thread === 1 ? 'Yes' : 'No');
            if (resp.data.user_name) {
                jQuery('#xf-thread-user-value').text(resp.data.user_name);
            }
            tb_remove();
        });
    });

    function xfLoadThreadPrefixes() {
        jQuery.ajax(ajaxurl + '?action=xf_forum&node_id=' + wpForumConnectForumId, {
            dataType: 'json',
        })
        .done(function (resp) {
            jQuery('#xf-thread-prefix option:not(.no-remove)').remove();
            jQuery(resp.prefixes).each(function (index, prefix) {
                option = jQuery('<option />', {
                    'value': prefix.id,
                    'text': prefix.title,
                    'selected': prefix.id == wpForumConnectPrefixId,
                });
                jQuery('#xf-thread-prefix').append(option);
            });
        });
    }

    function xfThreadConfigRefresh() {
        jQuery.ajax(ajaxurl + '?action=xf_forum&node_id=' + wpForumConnectForumId, {
            dataType: 'json',
        })
        .done(function (resp) {
            jQuery('#xf-thread-forum-value').text(resp.title);
            jQuery(resp.prefixes).each(function (index, prefix) {
                if (prefix.id == wpForumConnectPrefixId) {
                    jQuery('#xf-thread-prefix-value').text(prefix.title);
                }
            });
        });
    }

    function toggleFields() {
        jQuery('#xf-thread-forum, #xf-thread-prefix, #xf-thread-user-search, #xf-thread-excerpt').parent().parent().toggle(!jQuery('#xf-thread-id').val());
    }

});