<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\Template;

/**
 * Class AdminMenu
 * @package AudentioForumConnect\Actions
 */
class AddMetaBoxes implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $option = get_option('wp_forum_connect');
        if ($option['always_use_defaults'] ?? false || $option['commenting_mode'] == 'auth_only') {
            return;
        }

        wp_enqueue_script('wp_forum_connect_admin', plugins_url('article-forum-connect/public/js/thread-config.js'), ['jquery'], false);

        add_meta_box(
            'xf_thread',
            \AudentioForumConnect::phrase('XenForo Thread'),
            array(AddMetaBoxes::class, 'meta_box_html'),
            'post',
            'side'
        );
    }

    public static function meta_box_html($post)
    {
        wp_enqueue_script('suggest');

        echo Template::render('meta_box', [
            'post' => $post,
        ]);
    }
}