<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class CommentPost
 * @package AudentioForumConnect\Actions
 */
class CommentPost implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($comment_ID, $comment_approved, $commentdata)
    {
        if (!$threadId = \AudentioForumConnect::get_post_thread_id($commentdata['comment_post_ID'])) {
            return;
        }

        $client = \AudentioForumConnect::AudentioForumConnectClientForUser($commentdata['user_id']);

        if (!$client) {
            return;
        }

        $data = [
            'wp_comment_id' => $comment_ID,
        ];

        if ($commentdata['comment_parent']) {
            if ($replyCommentXfPostId = get_comment_meta($commentdata['comment_parent'], 'xf_post_id', true)) {

                try {

                    $xfPost = $client->xf->post->getPost($replyCommentXfPostId);
                    //echo '<pre>';print_r($xfPost);exit;

                    $commentdata['comment_content'] = '[QUOTE="' . $xfPost->User['username'] . ', post: ' . $xfPost->post_id . ', member: ' . $xfPost->User['user_id'] . '"]' . "\n" . $xfPost->message . "\n" . '[/QUOTE]' . "\n" . $commentdata['comment_content'];

                } catch (\AudentioForumConnect\Exception\RequestException\NotFoundRequestException $e) {

                }

            }
        }

        $post = $client->xf->post->create($threadId, $commentdata['comment_content'], $data);

        update_comment_meta($comment_ID, 'xf_post_id', $post->post_id);
    }
}