<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\Template;

/**
 * Class EditUserProfileUpdate
 * @package AudentioForumConnect\Actions
 */
class EditUserProfileUpdate implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($userId)
    {
        if (empty($_POST['_wpnonce']) || !wp_verify_nonce($_POST['_wpnonce'], 'update-user_' . $userId)) {
            return;
        }

        if (!current_user_can('edit_user', $userId)) {
            return false;
        }

        if (isset($_POST['xf_user_id'])) {
            update_user_meta($userId, 'xf_user_id', intval($_POST['xf_user_id']));
        }
        if (isset($_POST['xf_api_key'])) {
            update_user_meta($userId, 'xf_api_key', sanitize_text_field($_POST['xf_api_key']));
        }
    }
}