<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\Template;

/**
 * Class EditedCategory
 * @package AudentioForumConnect\Actions
 */
class EditedCategory implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($tagId)
    {
        if (empty($_POST['_wpnonce']) || !wp_verify_nonce($_POST['_wpnonce'], 'update-tag_' . $tagId)) {
            return;
        }

        if (!current_user_can('manage_categories', $tagId)) {
            return false;
        }

        update_term_meta($tagId, 'xf_forum_id', intval($_POST['xf_forum_id']));
        update_term_meta($tagId, 'xf_prefix_id', intval($_POST['xf_prefix_id']));
    }
}