<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class Init
 * @package AudentioForumConnect\Actions
 */
class Init implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        add_option('xf_api_bridge', [
            'xf_url' => '',
            'api_key' => ''
        ]);

        register_meta('post', 'xf_promoted_thread_id', [
            'type' => 'integer',
            'description' => __('XF Promoted Thread ID'),
            'single' => true,
            'show_in_rest' => true
        ]);

        register_meta('user', 'xf_user_id', [
            'type' => 'integer',
            'description' => __('XF User ID'),
            'single' => true,
            'show_in_rest' => true
        ]);

        register_meta('user', 'xf_api_key', [
            'type' => 'string',
            'description' => __('XF API Key'),
            'single' => true,
            'show_in_rest' => true
        ]);

        register_meta('comment', 'xf_post_id', [
            'type' => 'integer',
            'description' => __('XF Post ID'),
            'single' => true,
            'show_in_rest' => true
        ]);

        add_shortcode('afc-xf-user-state', [\AudentioForumConnect::class, 'shortcode_xf_user_state']);
    }
}