<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class RestApiInit
 * @package AudentioForumConnect\Actions
 */
class RestApiInit implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($wp_rest_server)
    {
        self::registerEndpoints();

        if (!\AudentioForumConnect::verifyWpApiKey()) {
            return;
        }

        $options = get_option('wp_forum_connect', []);
        $userId = $options['wp_api_user'] ?? 1;

        wp_clear_auth_cookie();
        wp_set_current_user($userId);
        wp_set_auth_cookie($userId, true, is_ssl());
    }

    private static function registerEndpoints()
    {
        register_rest_route('wpconnect/v1', '/verify-config', array(
            'methods' => 'POST',
            'callback' => [get_called_class(), 'verifyConfig'],
            'permission_callback' => '__return_true',
        ));
    }

    public static function verifyConfig()
    {
        echo json_encode([
            'valid' => \AudentioForumConnect::verifyWpApiKey(),
        ]);
        exit;
    }
}