<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class WpAjaxWpForumConnectCheckPlus
 * @package AudentioForumConnect\Actions
 */
class WpAjaxWpForumConnectCheckPlus implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $option = get_option('wp_forum_connect');
        $wpAPiKey = get_option('wp_forum_connect_wp_api_key');

        if (!$option['xf_url'] || !$wpAPiKey) {
            self::fail();
        }

        try {

            $response = (new \WP_Http_Curl)->request(rtrim($option['xf_url'], '/') . '/wpconnect-plus', [
                'method' => 'POST',
                'body' => [
                    'wp_api_key' => $wpAPiKey,
                ],
            ]);

            $response['body'] = json_decode($response['body'], true);
            if (!empty($response['body']['plus']) && $response['body']['plus']) {
                self::success();
            }

        } catch (\Exception $e) {
            self::fail();
        }

        self::fail();
    }

    private static function fail()
    {
        update_option('wp_forum_connect_plus', '0');

        echo json_encode([
            'plus' => false,
        ]);
        exit;
    }

    private static function success()
    {
        update_option('wp_forum_connect_plus', '1');

        echo json_encode([
            'plus' => true,
        ]);
        exit;
    }
}