<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\Template;

/**
 * Class WpAjaxWpForumConnectPostComment
 * @package AudentioForumConnect\Actions
 */
class WpAjaxWpForumConnectPostComment implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        if (empty($_POST['comment_post_ID'])) {
            exit;
        }

        if (!$xfThreadId = \AudentioForumConnect::get_post_thread_id(intval($_POST['comment_post_ID']))) {
            exit;
        }

        if (empty($_POST['comment'])) {
            echo json_encode([
                'error' => \AudentioForumConnect::phrase('Please enter a comment'),
            ]);
            exit;
        }

        $client = \AudentioForumConnect::AudentioForumConnectClientForUser();

        try {

            $xfPost = $client->xf->post->create($xfThreadId, $_POST['comment']);

            $pagination = \AudentioForumConnect::get_xf_pagination(intval($_POST['comment_post_ID']));
            $redirectUrl = $pagination->last_page > 1 ? $xfPost->view_url : '';

        } catch (\Exception $e) {
            echo json_encode([
                'error' => \AudentioForumConnect::phrase('Something went wrong, please refresh and try again'),
            ]);
            exit;
        }

        echo json_encode([
            'comment' => Template::render('comment', [
                'xfPost' => (array)\AudentioForumConnect::format_xf_posts([$xfPost])[0],
            ], true),
            'redirectUrl' => $redirectUrl,
        ]);
        exit;
    }
}