<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class WpAjaxWpForumConnectPostVote
 * @package AudentioForumConnect\Actions
 */
class WpAjaxWpForumConnectPostVote implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        if (empty($_POST['id']) || empty($_POST['type'])) {
            exit;
        }

        $client = \AudentioForumConnect::AudentioForumConnectClientForUser();

        try {

            $xfPost = $client->xf->post->vote(intval($_POST['id']), sanitize_text_field($_POST['type']));

        } catch (\Exception $e) {
            echo json_encode([
                'error' => \AudentioForumConnect::phrase('Something went wrong, please refresh and try again'),
            ]);
            exit;
        }

        echo json_encode([
            'comment' => \AudentioForumConnect::format_xf_posts([$xfPost])[0],
        ]);
        exit;
    }
}