<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class WpAjaxWpForumConnectUserLogin
 * @package AudentioForumConnect\Actions
 */
class WpAjaxWpForumConnectUserLogin implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $client = \AudentioForumConnect::AudentioForumConnectClient();

        try {

            $xfUser = $client->xf->auth->auth(sanitize_text_field($_POST['username']) ?? '', sanitize_text_field($_POST['password']) ?? '');

        } catch (\AudentioForumConnect\Exception\RequestException\NoPermissionRequestException $e) {
            echo json_encode([
                'error' => $e->getMessage(),
            ]);
            exit;
        } catch (\Exception $e) {
            echo json_encode([
                'error' => \AudentioForumConnect::phrase('Something went wrong, please refresh and try again'),
            ]);
            exit;
        }

        update_user_meta(get_current_user_id(), 'xf_user_id', $xfUser->user_id);

        echo json_encode([
            'success' => true,
        ]);
        exit;
    }
}