<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class AdminMenu
 * @package AudentioForumConnect\Actions
 */
class WpAjaxXfForum implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $client = \AudentioForumConnect::AudentioForumConnectClient();

        $node = $client->xf->node->getNode(intval($_GET['node_id']));

        $prefixList = array_map(function ($prefix) {
            return [
                'id' => $prefix['prefix_id'],
                'title' => $prefix['title'],
            ];
        }, $node->type_data['prefixes']);

        $data = [
            'title' => $node->title,
            'prefixes' => $prefixList,
        ];

        echo json_encode($data);
        exit;
    }
}