<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class AdminMenu
 * @package AudentioForumConnect\Actions
 */
class WpAjaxXfNodeList implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $client = \AudentioForumConnect::AudentioForumConnectClient();

        // try {
        //     $nodes = $client->xf->node->getNodes()->nodes;
        // } catch (\Exception $e) {
        //     echo json_encode([]);
        //     exit;
        // }

        $nodes = $client->xf->node->getNodes()->nodes;

        $nodeList = array_map(function ($node) {
            return [
                'id' => $node->node_id,
                'title' => str_repeat('-', count($node->breadcrumbs)) . ' ' . $node->title,
                'selectable' => $node->node_type_id == 'Forum',
            ];
        }, $nodes);

        echo json_encode($nodeList);
        exit;
    }
}