<?php

namespace AudentioForumConnect\Actions;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class AdminMenu
 * @package AudentioForumConnect\Actions
 */
class WpAjaxXfSavePostThreadConfig implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        $postId = intval($_POST['post_id']);

        if (!empty($_POST['thread_id'])) {

            try {

                $client = \AudentioForumConnect::AudentioForumConnectClient();
                $thread = $client->xf->thread->getThread(intval($_POST['thread_id']));

                \AudentioForumConnect::update_post_thread_id($postId, intval($_POST['thread_id']));
                return;

            } catch (\AudentioForumConnect\Exception\RequestException\NotFoundRequestException $e) {

                echo json_encode([
                    'success' => false,
                    'message' => \AudentioForumConnect::phrase('Invalid thread ID'),
                ]);
                exit;

            }
        }

        \AudentioForumConnect::update_post_thread_id($postId, $_POST['thread_id'] ? intval($_POST['thread_id']) : '');
        update_post_meta($postId, 'xf_create_thread', intval($_POST['create_thread']));
        update_post_meta($postId, 'xf_forum_id', intval($_POST['forum_id']));
        update_post_meta($postId, 'xf_prefix_id', intval($_POST['prefix_id']));
        update_post_meta($postId, 'xf_user_id', intval($_POST['user_id']));
        update_post_meta($postId, 'xf_excerpt', sanitize_text_field($_POST['excerpt']));

        echo json_encode([
            'success' => true,
            'data' => [
                'create_thread' => intval($_POST['create_thread']),
                'user_name' => get_user_by('id', intval($_POST['user_id']))->display_name
            ],
        ]);
        exit;
    }
}