<?php

namespace AudentioForumConnect\Filters;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\BbCodeParser;

/**
 * Class CommentFormFields
 * @package AudentioForumConnect\Filters
 */
class CommentFormFields implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($comment_fields)
    {
        if (!\AudentioForumConnect::use_xf_auth()) {
            return $comment_fields;
        }

        unset($comment_fields['author']);
        unset($comment_fields['email']);
        unset($comment_fields['url']);
        unset($comment_fields['cookies']);
        if (!\AudentioForumConnect::has_xf_user()) {
            unset($comment_fields['comment']);
        }

        return $comment_fields;
    }

    public function getPriority()
    {
        return 999999999;
    }
}