<?php

namespace AudentioForumConnect\Filters;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\BbCodeParser;
use AudentioForumConnect\Util\Template;

/**
 * Class CommentsTemplate
 * @package AudentioForumConnect\Filters
 */
class CommentsTemplate implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback()
    {
        global $post;

        if (!$threadId = \AudentioForumConnect::get_post_thread_id($post->ID)) {
            return;
        }

        try {
            $xfThread = \AudentioForumConnect::get_xf_thread();
        } catch (\Exception $e) {
            \AudentioForumConnect::checkConnection(false);
            return;
        }

        update_post_meta($post->ID, 'xf_reply_count', $xfThread->reply_count);

        $option = get_option('wp_forum_connect');

        if ($option['integration_type'] == 'iframe') {
            return Template::find('comments_iframe');
        }

        if ($option['integration_type'] == 'session_cookie' || ($option['integration_type'] == 'wp_user' && !($option['native_comments'] ?? null))) {
            wp_enqueue_script('wp_forum_connect_post_comments', plugins_url('article-forum-connect/public/js/post-comments.js'), ['jquery'], '1.0.5', true);
            return Template::find('comments_wp_connect');
        }
    }

    public function getPriority()
    {
        return 999999999;
    }
}