<?php

namespace AudentioForumConnect\Filters;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;
use AudentioForumConnect\Util\BbCodeParser;

/**
 * Class PreprocessComment
 * @package AudentioForumConnect\Filters
 */
class PreprocessComment implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($commentdata)
    {
        if (!\AudentioForumConnect::use_xf_auth()) {
            return $commentdata;
        }

        unset($commentdata['user_ID'], $commentdata['user_id']);

        $client = \AudentioForumConnect::AudentioForumConnectClientForUser(null, false);

        if ($client) {
            try {
                $user = $client->xf->me->me();

                $commentdata['comment_author'] = $user->username;
                $commentdata['comment_author_email'] = $user->email;
                $commentdata['comment_author_url'] = $user->view_url;
                $commentdata['comment_meta'] = [
                    'xf_user_id' => $user->user_id,
                    'avatar' => $user->avatar_urls['l'] ?? '',
                ];
                $commentdata['comment_with_xf_auth'] = 1;
            } catch (\Exception $e) {

            }
        }

        return $commentdata;
    }

    public function getPriority()
    {
        return 999999999;
    }
}