<?php

namespace AudentioForumConnect\Filters;

use AudentioForumConnect\Client;
use AudentioForumConnect\HookInterface;
use AudentioForumConnect\HookTrait;

/**
 * Class TheContent
 * @package AudentioForumConnect\Filters
 */
class TheContent implements HookInterface
{
    use HookTrait;

    /**
     *
     */
    public static function callback($content)
    {
        global $post;

        if (!$post) {
            return $content;
        }

        $option = get_option('wp_forum_connect');

        if (isset($option['hide_article_discussion_link']) && $option['hide_article_discussion_link']) {
            return $content;
        }

        $link = '';
        $threadId = \AudentioForumConnect::get_post_thread_id($post->ID);

        if ($threadId) {
            try {

                $client = \AudentioForumConnect::AudentioForumConnectClient();
                $thread = $client->xf->thread->getThread($threadId);

                $link = '<p><a href="' . $thread->view_url . '" target="_blank">' . \AudentioForumConnect::phrase('Forumda Oku...') . '</a></p>';

            } catch (\Exception $e) {
                \AudentioForumConnect::checkConnection(false);
            }
        }

        return $content . $link;
    }
}