<?php

namespace AudentioForumConnect;

/**
 * Trait HookTrait
 * @package AudentioForumConnect
 */
trait HookTrait
{
    /**
     * @return string
     */
    public function getHook()
    {
        $className = get_called_class();

        $sepPos = strrpos($className, "\\");
        $className = substr($className, $sepPos === false ? 0 : ($sepPos + 1));

        preg_match_all('!([A-Z][A-Z0-9]*(?=$|[A-Z][a-z0-9])|[A-Za-z][a-z0-9]+)!', $className, $matches);
        $return = $matches[0];
        foreach ($return as &$match) {
            $match = $match == strtoupper($match) ? strtolower($match) : lcfirst($match);
        }
        return implode('_', $return);
    }

    /**
     * @return array
     */
    public function getCallback()
    {
        return [get_called_class(), 'callback'];
    }

    /**
     * @return int
     */
    public function getPriority()
    {
        return 10;
    }
}