<?php

namespace AudentioForumConnect\Util;

use Genert\BBCode\BBCode;

/**
 * Class BbCodeParser
 * @package AudentioForumConnect\Util
 */
class BbCodeParser
{
    /**
     * @var BBCode
     */
    protected $parser;

    /**
     * BbCodeParser constructor.
     */
    public function __construct()
    {
        $this->parser = new BBCode();
        $this->configureDefaultTags();
    }

    /**
     *
     */
    protected function configureDefaultTags()
    {
        $parser = $this->parser;
        $parser->addLinebreakParser();
    }

    /**
     * @param $html
     * @return string
     */
    public function htmlToBbCode($html)
    {
        return $this->parser->convertFromHtml($html);
    }

    /**
     * @param $bbCode
     * @return string
     */
    public function bbCodeToHtml($bbCode)
    {
        return $this->parser->convertToHtml($bbCode);
    }
}